package com.company.jmix.test.screen.alert

import io.jmix.ui.screen.*
import com.company.jmix.test.entity.Alert
import io.jmix.ui.ScreenBuilders
import io.jmix.ui.action.Action
import io.jmix.ui.component.GroupTable
import org.springframework.beans.factory.annotation.Autowired

@UiController("jt_Alert.browse")
@UiDescriptor("alert-browse.xml")
@LookupComponent("alertsTable")
class AlertBrowse : StandardLookup<Alert>() {
    @Autowired
    private lateinit var screenBuilders: ScreenBuilders

    @Autowired
    private lateinit var alertsTable: GroupTable<Alert>

    @Subscribe("alertsTable.create")
    private fun onAlertsTableCreate(event: Action.ActionPerformedEvent) {
        screenBuilders.editor(alertsTable)
            .withScreenClass(AlertCreate::class.java)
            .newEntity()
            .show()
    }


}