package com.company.jmix.test.screen.alert

import io.jmix.ui.screen.*
import com.company.jmix.test.entity.Alert
import com.company.jmix.test.entity.AlertModel
import com.company.jmix.test.entity.Model
import io.jmix.core.DataManager
import io.jmix.ui.UiComponents
import io.jmix.ui.component.CheckBox
import io.jmix.ui.component.Component
import io.jmix.ui.model.CollectionContainer
import org.springframework.beans.factory.annotation.Autowired

@UiController("jt_Alert.create")
@UiDescriptor("alert-create.xml")
@EditedEntityContainer("alertDc")
class AlertCreate : StandardEditor<Alert>() {
    @Autowired
    private lateinit var dataManager: DataManager

    @Autowired
    private lateinit var alertModelsDc: CollectionContainer<AlertModel>

    @Subscribe
    private fun onAfterShow(event: AfterShowEvent) {
        initAlertModelsDc()
    }

    private fun initAlertModelsDc() {
        val allModels = dataManager.load(Model::class.java).all().list()
        val alertModels = allModels.map {
            val alertModel = dataManager.create(AlertModel::class.java)
            alertModel.alert = editedEntity
            alertModel.model = it
            alertModel
        }
        alertModelsDc.setItems(alertModels)
    }

    @Subscribe
    private fun onBeforeCommitChanges(event: BeforeCommitChangesEvent) {
        val alertModelsToCommit = alertModelsDc.items.filter { it.isInAlert == true }
        event.dataContext.merge(alertModelsToCommit)
    }

}